#include "node.hpp"
#include <sstream>
#include "display_node.hpp"

using namespace std;

namespace mcts
{
  uint32_t node::size() const
  {
    uint32_t res = 1;
    for (uint16_t i = 0; i < number_of_children; ++i) 
      {
	res += children[i].size();
      }
    return res;
  }

  string node::to_string() const
  {
    stringbuf buffer;
    ostream os(&buffer);
    util::display_node::node_to_ascii(os, this);
    os << endl;
    return buffer.str();
  }

  ostream& operator<<(ostream& os, const node& n)
  {
    util::display_node::node_to_ascii(os, &n);
    os << endl;
    return os;
  }
}
